#include "m_pd.h"

static t_class *through_class;

typedef struct _through
{
  t_object x_obj;
  float x_f;
} t_through;

static t_int *through_perform(t_int *w)
{
  t_float *s0 = (t_float*)(w[1]);
  t_float *s1 = (t_float*)(w[2]);
  int N = (int)(w[3]);
  
  int n;
  
  for (n = 0; n < N; n++)
  {
    s1[n] = s0[n];
  }
  
  return (w + 4);
}

void through_dsp(t_through *x, t_signal **sp)
{
  dsp_add(through_perform, 3, sp[0]->s_vec, sp[1]->s_vec, sp[0]->s_n);
}

void *through_new(void)
{
  t_through *x = (t_through *)pd_new(through_class);
  outlet_new(&x->x_obj, gensym("signal"));
  return (void *)x;
}

void through_tilde_setup(void)
{
  through_class = class_new(gensym("through~"),
    (t_newmethod)through_new, 0, sizeof(t_through), CLASS_DEFAULT, 0);
  CLASS_MAINSIGNALIN(through_class, t_through, x_f);
  class_addmethod(through_class, (t_method)through_dsp, gensym("dsp"), 0);
}
